<template>
    <div class="w-full">
        <section class="m-2">
            <bread-crumbs :name="project?.name ?? 'No name'" />
        </section>

        <section>
            <div class="overflow-x-auto">
                <table class="table">
                    <!-- head -->
                    <thead>
                        <tr>
                            <th class="w-14">Completada</th>
                            <th>Tarea</th>
                            <th>Completada el</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="task in project?.tasks" :key="task.id" class="hover">
                            <th>
                                <input @change="toggleTask(task.id)" type="checkbox" :checked="!!task.completedAt"
                                    class="checkbox checkbox-primary">
                            </th>
                            <td>{{ task.name }}</td>
                            <td>{{ task.completedAt }}</td>
                        </tr>

                        <tr class="hover">
                            <th class="w-14"></th>
                            <td>
                                <input ref="inputRef" @keypress.enter="addTask" v-model="projectName" type="text"
                                    class="input input-primary w-full opacity-60 transition-all hover:opacity-100 focus:opacity-100"
                                    placeholder="Nueva tarea">
                            </td>
                            <td></td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </section>
    </div>
</template>

<script lang="ts" setup>
import BreadCrumbs from '@/modules/common/components/BreadCrumbs.vue'
import { useProjectsStore } from '../store/projects.store';
import { ref, watch } from 'vue';
import type { Project } from '../interfaces/project.interface';
import { useRouter } from 'vue-router';

interface Props {
    id: string
}

const router = useRouter()
const props = defineProps<Props>()
const projectStore = useProjectsStore()

const project = ref<Project | null>()
const projectName = ref('')
// const inputRef = ref<HTMLInputElement | null>(null)

const addTask = () => {
    if (!project.value) return

    // if (projectName.value.length === 0) {
    //     inputRef.value?.focus()
    //     return
    // }

    projectStore.addTaskToProject(project.value, projectName.value)

    projectName.value = ''
}

const toggleTask = (taskId: string) => {
    if (!project.value) return

    projectStore.toggleTask(project.value, taskId)
}

watch(() => props.id, () => {
    project.value = projectStore.projectList.find((project) => project.id === props.id)
    if (!project.value) {
        router.replace('/')
    }
}, {
    immediate: true,
})

</script>